#include <bits/stdc++.h>
using namespace std;
long long n, q, d, p, a, niz[300005], niz2[300005];
int main(){
    scanf("%lld %lld", &n, &q);
    for(int i=1; i<=n; i++){
        scanf("%lld %lld", &d, &p);
        niz[d]=p;
    }
    long long trPlazma=0;
    for(int i=1; i<=300000; i++){
        trPlazma+=niz[i];
        if(trPlazma){
            niz2[i]=niz2[i-1]+1;
            trPlazma--;
        }
        else{
            niz2[i]=niz2[i-1];
        }
    }
    for(int i=1; i<=q; i++){
        scanf("%lld", &a);
        printf("%lld\n", niz2[a]);
    }
    return 0;
}